Require Import bool.
Require Import connectives.
Require Import div_mod.
Require Import leibniz.
Require Import logic.
Require Import nat.
Require Import primes.
Parameter gcd_aux : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Parameter gcd_aux_body : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Axiom axiom_gcd_aux : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (gcd_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p).
Definition eq_gcd_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (gcd_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p)) ((axiom_gcd_aux) (p)).
Definition sym_eq_gcd_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p) (gcd_aux p) := fun (p:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p)) ((eq_gcd_aux) (p)).
Axiom axiom_gcd_aux_body_S : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (gcd_aux_body (nat.S p)) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) (primes.dividesb n m)).
Definition eq_gcd_aux_body_S : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (gcd_aux_body (nat.S p)) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) (primes.dividesb n m)) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body (nat.S p))) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) (primes.dividesb n m))) ((axiom_gcd_aux_body_S) (p)).
Definition sym_eq_gcd_aux_body_S : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) (primes.dividesb n m)) (gcd_aux_body (nat.S p)) := fun (p:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body (nat.S p))) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) (primes.dividesb n m))) ((eq_gcd_aux_body_S) (p)).
Definition divides_mod_to_divides : forall (p:nat.nat), forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (primes.divides p (div_mod.mod m n)) -> (primes.divides p n) -> primes.divides p m := fun (p:nat.nat) => fun (m:nat.nat) => fun (n:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (_clearme:primes.divides p (div_mod.mod m n)) => ((((((primes.match_divides_prop) (p)) (div_mod.mod m n)) ((primes.divides p n) -> primes.divides p m)) (fun (q1:nat.nat) => fun (eq1:logic.eq (nat.nat) (div_mod.mod m n) (nat.times p q1)) => (fun (_clearme0:primes.divides p n) => ((((((primes.match_divides_prop) (p)) (n)) (primes.divides p m)) (fun (q2:nat.nat) => fun (eq2:logic.eq (nat.nat) n (nat.times p q2)) => (((((primes.quotient) (p)) (m)) (nat.plus (nat.times q2 (div_mod.div m n)) q1)) (((((((logic.eq_ind_r) (nat.nat)) (nat.plus (nat.times p (nat.times q2 (div_mod.div m n))) (nat.times p q1))) (fun (x:nat.nat) => logic.eq (nat.nat) m x)) (((((((logic.eq_ind) (nat.nat)) (div_mod.mod m n)) (fun (x_1:nat.nat) => logic.eq (nat.nat) m (nat.plus (nat.times p (nat.times q2 (div_mod.div m n))) x_1))) (((((((logic.eq_ind) (nat.nat)) (nat.times (nat.times p q2) (div_mod.div m n))) (fun (x_1:nat.nat) => logic.eq (nat.nat) m (nat.plus x_1 (div_mod.mod m n)))) (((((((logic.eq_ind) (nat.nat)) (n)) (fun (x_1:nat.nat) => logic.eq (nat.nat) m (nat.plus (nat.times x_1 (div_mod.div m n)) (div_mod.mod m n)))) (((((((logic.rewrite_r) (nat.nat)) (nat.plus (div_mod.mod m n) (nat.times n (div_mod.div m n)))) (fun (__:nat.nat) => logic.eq (nat.nat) m __)) (((((((logic.rewrite_l) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (nat.nat) m __)) (((logic.refl) (nat.nat)) (m))) (nat.plus (div_mod.mod m n) (nat.times n (div_mod.div m n)))) (((((((logic.rewrite_l) (nat.nat)) (nat.plus (nat.times n (div_mod.div m n)) (div_mod.mod m n))) (fun (__:nat.nat) => logic.eq (nat.nat) m __)) (((((((logic.rewrite_l) (nat.nat)) (nat.times (div_mod.div m n) n)) (fun (__:nat.nat) => logic.eq (nat.nat) m (nat.plus __ (div_mod.mod m n)))) (((div_mod.div_mod) (m)) (n))) (nat.times n (div_mod.div m n))) (((nat.commutative_times) (div_mod.div m n)) (n)))) (nat.plus (div_mod.mod m n) (nat.times n (div_mod.div m n)))) (((nat.commutative_plus) (nat.times n (div_mod.div m n))) (div_mod.mod m n))))) (nat.plus (nat.times n (div_mod.div m n)) (div_mod.mod m n))) (((nat.commutative_plus) (nat.times n (div_mod.div m n))) (div_mod.mod m n)))) (nat.times p q2)) (eq2))) (nat.times p (nat.times q2 (div_mod.div m n)))) ((((nat.associative_times) (p)) (q2)) (div_mod.div m n)))) (nat.times p q1)) (eq1))) (nat.times p (nat.plus (nat.times q2 (div_mod.div m n)) q1))) ((((nat.distributive_times_plus) (p)) (nat.times q2 (div_mod.div m n))) (q1)))))) (_clearme0))))) (_clearme))).
Definition divides_to_gcd_aux : forall (p:nat.nat), forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O p) -> (nat.lt nat.O n) -> (primes.divides n m) -> logic.eq (nat.nat) (gcd_aux p m n) n := fun (p:nat.nat) => fun (m:nat.nat) => fun (n:nat.nat) => fun (posp:nat.lt nat.O p) => (((((nat.lt_O_n_elim) (p)) (posp)) (fun (__:nat.nat) => (nat.lt nat.O n) -> (primes.divides n m) -> logic.eq (nat.nat) (gcd_aux __ m n) n)) (fun (l:nat.nat) => (((sym_eq_gcd_aux) (nat.S l)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (primes.divides n m) -> logic.eq (nat.nat) (y m n) n)) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body)) (l)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (primes.divides n m) -> logic.eq (nat.nat) (y m n) n)) ((((sym_eq_gcd_aux_body_S) (l)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (primes.divides n m) -> logic.eq (nat.nat) (y m n) n)) (fun (posn:nat.lt nat.O n) => (fun (divnm:primes.divides n m) => (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) n (gcd_aux l n (div_mod.mod m n)) x) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (n)) (gcd_aux l n (nat.match_nat_type (nat.nat) m (fun (p0:nat.nat) => div_mod.mod_aux m m p0) n))) (fun (y:nat.nat) => logic.eq (nat.nat) y n)) (((logic.refl) (nat.nat)) (n)))) (primes.dividesb n m)) (((((primes.divides_to_dividesb_true) (n)) (m)) (posn)) (divnm))))))))).
Definition not_divides_to_gcd_aux : forall (p:nat.nat), forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (connectives.Not (primes.divides n m)) -> logic.eq (nat.nat) (gcd_aux (nat.S p) m n) (gcd_aux p n (div_mod.mod m n)) := fun (p:nat.nat) => fun (m:nat.nat) => fun (n:nat.nat) => (((sym_eq_gcd_aux) (nat.S p)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (connectives.Not (primes.divides n m)) -> logic.eq (nat.nat) (y m n) (gcd_aux p n (div_mod.mod m n)))) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body)) (p)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (connectives.Not (primes.divides n m)) -> logic.eq (nat.nat) (y m n) (gcd_aux p n (div_mod.mod m n)))) ((((sym_eq_gcd_aux_body_S) (p)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (connectives.Not (primes.divides n m)) -> logic.eq (nat.nat) (y m n) (gcd_aux p n (div_mod.mod m n)))) (fun (lenm:nat.lt nat.O n) => (fun (divnm:connectives.Not (primes.divides n m)) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) x) (gcd_aux p n (div_mod.mod m n)))) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (n)) (gcd_aux p n (nat.match_nat_type (nat.nat) m (fun (p0:nat.nat) => div_mod.mod_aux m m p0) n))) (fun (y:nat.nat) => logic.eq (nat.nat) y (gcd_aux p n (nat.match_nat_type (nat.nat) m (fun (p0:nat.nat) => div_mod.mod_aux m m p0) n)))) (((logic.refl) (nat.nat)) (gcd_aux p n (nat.match_nat_type (nat.nat) m (fun (p0:nat.nat) => div_mod.mod_aux m m p0) n))))) (primes.dividesb n m)) (((((primes.not_divides_to_dividesb_false) (n)) (m)) (lenm)) (divnm))))))).
Definition divides_gcd_aux_mn : forall (p:nat.nat), forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n p) -> connectives.And (primes.divides (gcd_aux p m n) m) (primes.divides (gcd_aux p m n) n) := fun (p:nat.nat) => ((((nat.nat_ind) (fun (_x_365:nat.nat) => forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n _x_365) -> connectives.And (primes.divides (gcd_aux _x_365 m n) m) (primes.divides (gcd_aux _x_365 m n) n))) (fun (m:nat.nat) => fun (n:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (lenm:nat.le n m) => (fun (lenO:nat.le n nat.O) => (((connectives.falsity) (connectives.And (primes.divides (gcd_aux nat.O m n) m) (primes.divides (gcd_aux nat.O m n) n))) ((((logic.absurd) (nat.lt nat.O n)) (posn)) ((((nat.le_to_not_lt) (n)) (nat.O)) (lenO)))))))) (fun (q:nat.nat) => fun (Hind:forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n q) -> connectives.And (primes.divides (gcd_aux q m n) m) (primes.divides (gcd_aux q m n) n)) => (fun (m:nat.nat) => fun (n:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (lenm:nat.le n m) => (fun (lenS:nat.le n (nat.S q)) => (((((((connectives.match_Or_prop) (primes.divides n m)) (connectives.Not (primes.divides n m))) (connectives.And (primes.divides (gcd_aux (nat.S q) m n) m) (primes.divides (gcd_aux (nat.S q) m n) n))) (fun (divnm:primes.divides n m) => (((((((logic.eq_ind_r) (nat.nat)) (n)) (fun (x:nat.nat) => connectives.And (primes.divides x m) (primes.divides x n))) (((((connectives.conj) (primes.divides n m)) (primes.divides n n)) (divnm)) ((primes.divides_n_n) (n)))) (gcd_aux (nat.S q) m n)) (((((((divides_to_gcd_aux) (nat.S q)) (m)) (n)) ((nat.lt_O_S) (q))) (posn)) (divnm))))) (fun (ndivnm:connectives.Not (primes.divides n m)) => (((((((logic.eq_ind_r) (nat.nat)) (gcd_aux q n (div_mod.mod m n))) (fun (x:nat.nat) => connectives.And (primes.divides x m) (primes.divides x n))) ((((((connectives.match_And_prop) (primes.divides (gcd_aux q n (div_mod.mod m n)) n)) (primes.divides (gcd_aux q n (div_mod.mod m n)) (div_mod.mod m n))) (connectives.And (primes.divides (gcd_aux q n (div_mod.mod m n)) m) (primes.divides (gcd_aux q n (div_mod.mod m n)) n))) (fun (H:primes.divides (gcd_aux q n (div_mod.mod m n)) n) => (fun (H1:primes.divides (gcd_aux q n (div_mod.mod m n)) (div_mod.mod m n)) => (((((connectives.conj) (primes.divides (gcd_aux q n (div_mod.mod m n)) m)) (primes.divides (gcd_aux q n (div_mod.mod m n)) n)) (((((((divides_mod_to_divides) (gcd_aux q n (div_mod.mod m n))) (m)) (n)) (posn)) (H1)) (H))) (H))))) ((((((Hind) (n)) (div_mod.mod m n)) (((((((connectives.match_Or_prop) (nat.lt nat.O (div_mod.mod m n))) (logic.eq (nat.nat) nat.O (div_mod.mod m n))) (nat.lt nat.O (div_mod.mod m n))) (fun (auto:nat.lt nat.O (div_mod.mod m n)) => (auto))) (fun (modO:logic.eq (nat.nat) nat.O (div_mod.mod m n)) => (((connectives.falsity) (nat.lt nat.O (div_mod.mod m n))) ((((logic.absurd) (primes.divides n m)) (((((primes.mod_O_to_divides) (n)) (m)) (posn)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) __ nat.O)) (((logic.refl) (nat.nat)) (nat.O))) (div_mod.mod m n)) (modO)))) (ndivnm))))) ((((nat.le_to_or_lt_eq) (nat.O)) (div_mod.mod m n)) ((nat.le_O_n) (div_mod.mod m n))))) ((((nat.lt_to_le) (div_mod.mod m n)) (n)) ((((div_mod.lt_mod_m_m) (m)) (n)) (posn)))) ((((nat.le_S_S_to_le) (div_mod.mod m n)) (q)) ((((((nat.transitive_le) (nat.S (div_mod.mod m n))) (n)) (nat.S q)) ((((div_mod.lt_mod_m_m) (m)) (n)) (posn))) (lenS)))))) (gcd_aux (nat.S q) m n)) ((((((not_divides_to_gcd_aux) (q)) (m)) (n)) (posn)) (ndivnm))))) (((primes.decidable_divides) (n)) (m)))))))) (p).
